\documentclass[unknownkeysallowed]{beamer}
\usepackage[utf8]{inputenc}
\usepackage{enumerate}
\usepackage{textcomp}
\usepackage{charter}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{url}
\usepackage{graphicx}
\usepackage{hyperref}
\usepackage{lmodern}
\usepackage{caption}
\usepackage{listings}
\usepackage{color}
\usepackage{xspace}
\usepackage{verbatim}
\usepackage{cprotect}
\usepackage{array}
\usepackage{multirow}
\usepackage{multicol}
\usepackage{multimedia}

\newlength{\Oldarrayrulewidth}
\newcommand{\Cline}[2]{
  \noalign{\global\setlength{\Oldarrayrulewidth}{\arrayrulewidth}}
  \noalign{\global\setlength{\arrayrulewidth}{#1}}\cline{#2}
  \noalign{\global\setlength{\arrayrulewidth}{\Oldarrayrulewidth}}}

%\usetheme{Berlin}
\usetheme{Madrid}
\usecolortheme{sidebartab}

\definecolor{dkgreen}{rgb}{0,0.6,0}
\definecolor{gray}{rgb}{0.5,0.5,0.5}
\definecolor{mauve}{rgb}{0.58,0,0.82}

\newcommand{\R}{\textsuperscript{\textregistered}}
\newcommand{\TM}{\textsuperscript{\texttrademark}}

\usepackage[style=authortitle,backend=bibtex]{biblatex}
\addbibresource{article.bib}

\definecolor{commentgreen}{rgb}{0.133,0.545,0.133}
\definecolor{keyblue}{rgb}{0,0,1}

\lstset{
  language=C++,
  basicstyle=\tiny\ttfamily,
  numbers=left,
  numberstyle=\tiny\ttfamily,
  stepnumber=1,
  numbersep=5pt,
  backgroundcolor=\color{white},
  showspaces=false,
  showstringspaces=false,
  showtabs=false,
  frame=single,
  tabsize=2,
  captionpos=b,
  breaklines=true,
  breakatwhitespace=false,
  escapeinside={(*@}{@*)},
  identifierstyle=\ttfamily,
  keywordstyle=\color[rgb]{0,0,1},
  commentstyle=\color[rgb]{0.133,0.545,0.133},
  stringstyle=\color[rgb]{0.627,0.126,0.941},
  moredelim=[is][\underbar]{**}{**},
}

\captionsetup{
  %figurename={\sc Fig.},
  figurename=,
  %tablename={\sc Tab.}
  tablename=
}

\lstdefinestyle{mycpp}
{
    language = C++,
    % numbers=left,
    % numbersep=0.3em,
    escapeinside={(*@}{@*)},
    tabsize=2,
    % basicstyle=\tiny\ttfamily,
    morekeywords = {constexpr,int8_t,int16_t,int32_t, size_t},
    % commentstyle=\color{comment-color},
}

\newcommand{\MIPP}{\texttt{MIPP}\xspace}
\newcommand{\longMIPP}{\textsc{MyIntrinsics++}\xspace}
\newcommand{\TSIMD}{\texttt{T-SIMD}\xspace}
\newcommand{\xsimd}{\texttt{xsimd}\xspace}
\newcommand{\simdpp}{\texttt{simdpp}\xspace}
\newcommand{\Vc}{\texttt{Vc}\xspace}
\newcommand{\VCL}{\texttt{VCL}\xspace}
\newcommand{\BoostSIMD}{\texttt{Boost.SIMD}\xspace}
\newcommand{\bSIMD}{\texttt{bSIMD}\xspace}

\newcommand{\Cxx}{\texttt{C++}\xspace}
\newcommand{\Cxy}[1]{\texttt{C++{#1}}\xspace}
\newcommand{\CppUnit}{\texttt{CppUnit}\xspace}

\setlength{\textfloatsep}{5pt}
\setlength{\parsep}{0pt}
\setlength{\parskip}{0pt}

\usepackage{pifont}
\newcommand{\cmark}{\textcolor{dkgreen}{\ding{51}}}
\newcommand{\xmark}{\textcolor{red}{\ding{55}}}
\newcommand{\Arikan}{Ar{\i}kan\xspace}

\renewcommand{\footnotesize}{\tiny}
% \renewcommand{\footnotesize}{\scriptsize}

\beamertemplatenavigationsymbolsempty

\setbeamertemplate{footline}
{%
  \begin{beamercolorbox}[wd=1.0\textwidth,ht=2.6ex,dp=1ex,leftskip=.5em,
    rig htskip=.5em]{author in head/foot}%
    \usebeamerfont{author in head/foot}%
    \insertshortauthor\hfill\insertshortinstitute%
  \end{beamercolorbox}%

  \hspace*{-4.0ex}\hspace*{0.3\textwidth}%

  \begin{beamercolorbox}[wd=1.0\textwidth,ht=2.6ex,dp=1ex,left,leftskip=.5em,
    rightskip=.5em]{title in head/foot}%
  \usebeamerfont{title in head/foot}%
    \insertshorttitle\hfill\insertframenumber{} / \inserttotalframenumber%
  \end{beamercolorbox}%
}

\setbeamertemplate{blocks}[rounded][shadow=true]
\setbeamercolor{block body}{fg=black,bg=blue!30}

\title[MIPP: a Portable C++ SIMD Wrapper and its use for ECC in 5G Standard]{
MIPP: a Portable C++ SIMD Wrapper and its use \\
for Error Correction Coding in 5G Standard}

\author[A. Cassagne  \and O. Aumage \and D. Barthou
\and C. Leroux \and C. Jégo]{
\underline{Adrien Cassagne}\inst{1,2}
\and Olivier Aumage\inst{1} \and Denis Barthou\inst{1}\\
\and Camille Leroux\inst{2} \and Christophe Jégo\inst{2}
}

\institute[Inria, IMS, U. of Bordeaux, LaBRI/CNRS]
{
  \inst{1}%
  Inria, Bordeaux Institute of Technology, U. of Bordeaux, LaBRI/CNRS, Bordeaux, France
  \and
  \inst{2}%
  IMS/CNRS, Bordeaux, France
}

\date[WPMVP 2018] % (optional)
{WPMVP, February 2018}

\titlegraphic{
  \includegraphics[height=0.75cm]{pics/inria_new.jpg}
  \hspace*{0.25cm}~%
  \includegraphics[height=0.60cm]{pics/ims}
  \hspace*{0.25cm}~%
  \includegraphics[width=1.6cm]{pics/bdx}
  \hspace*{0.25cm}~%
  \includegraphics[height=0.85cm]{pics/labri}
}

\begin{document}

\begin{frame}
  \titlepage
\end{frame}

\section{Introduction}

\subsection{Error Correction Codes}

\begin{frame}
  \frametitle{Context: Error Correction Codes (ECC)}
  \begin{itemize}
    \item Algorithms that enable \textbf{reliable delivery of digital data}
    \begin{itemize}
      \item \textbf{Redundancy} for error correction
    \end{itemize}
    \item Usually, \textbf{hardware implementation}
    \item Growing interest for \textbf{software implementation}
    \begin{itemize}
      \item End-user utilization (low power consumption processors)
      \item Algorithm validation (Monte-Carlo simulations)
      \item \textbf{Requires performance}
    \end{itemize}
  \end{itemize}
  \begin{figure}[htp]
    \centering
    \includegraphics[width=0.8\textwidth]{figs/communication_chain_dec_chn}
    \caption{The communication chain}
    \label{diagram:communication_chain}
  \end{figure}
\end{frame}

\subsection{5G Standard}

\begin{frame}
  \frametitle{Context: 5G Standard}
  \begin{itemize}
    \item \textbf{Many devices} connected to Internet via \textbf{wireless interfaces}
    \item Large zoo of devices: \textbf{Flexibility}
    \item Varied, complex ECC algorithms: \textbf{Expensive testing and validation}
    \item<2> \alert<2>{\textbf<2>{$\Rightarrow$ Portable SIMD library}}
  \end{itemize}

  \begin{figure}[htp]
    \centering
    \includegraphics[width=0.8\textwidth]{pics/5G}
  \end{figure}
\end{frame}

\subsection{Proposal}

\begin{frame}
  \frametitle{Proposal: \longMIPP (\MIPP)}
  \begin{itemize}
    \item<1-> SIMD \textbf{\Cxx wrapper}
    \begin{itemize}
      \item<1-> Maximizes code portability
      \item<1-> \textbf{Improves expressiveness} over intrinsics
      \item<1-> \textbf{No dependencies} to other libraries
    \end{itemize}
    \item<2-> Programming model \textbf{close to intrinsics}
    \begin{itemize}
      \item<2-> Whenever possible, \textbf{one statement = one intrinsic}
      \item<2-> One variable = one register allocation
    \end{itemize}
    % \item<3-> Open-source: \textcolor{blue}{\url{https://github.com/aff3ct/MIPP}}
  \end{itemize}
  \pause[3]
  \begin{figure}[htp]
    \centering
    \includegraphics[width=0.5\textwidth]{pics/mipp}
    \caption{\MIPP \MIPP!}
    \label{pic:mipp}
  \end{figure}
\end{frame}

\section{MIPP}

\subsection{Programming Interfaces}

\begin{frame}[fragile]
  \frametitle{\MIPP: Programming Interfaces}
  \begin{itemize}
    \item The Low-Level \MIPP Interface (low)
    \begin{itemize}
      \item Similar to SIMD intrinsics: \alert{Untyped} registers, \alert{typed} operations
      \item Portability through \textbf{template specialization} and \textbf{function inlining}
    \end{itemize}
  \end{itemize}
  \vspace{0.3cm}
  \pause
  \begin{itemize}
    \item The Medium-Level \MIPP Interface (med.)
    \begin{itemize}
      \item \alert{Typed} registers, \alert{polymorphic} operations
      \item Based on \MIPP Low Level Interface
      \item Typing through \textbf{object encapsulation} and \textbf{operator overloading}
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}[containsverbatim,fragile]
  \frametitle{\MIPP: Low Level Interface (low)}
  Similar to SIMD intrinsics: Untyped registers, typed operations
  \vspace{0.3cm}
  \begin{itemize}
    \item Abstract SIMD \textbf{data register} (\verb|mipp::reg|)
    \begin{itemize}
      \item \textbf{The number of elements} in a register: \texttt{mipp::N<\textcolor{blue}{T}>()}
    \end{itemize}
    \item Abstract SIMD \textbf{mask register} (\verb|mipp::msk|)
    \item Intrinsic functions wrapped into \MIPP functions
    \begin{itemize}
      \begin{columns}[t]
        \begin{column}[T]{9.0cm}
          \begin{lstlisting}[style = mycpp, label={lst:specialization}, morekeywords = {__mm256,__mm256d,reg}, escapechar=\%]
template<> mipp::reg mipp::add<float>(mipp::reg a, mipp::reg b)
{
  return (mipp::reg) _mm256_add_%\alert<2>{\texttt{ps}}%((__mm256) a, (__mm256) b);
}
template<> mipp::reg mipp::add<double>(mipp::reg a, mipp::reg b)
{
  return (mipp::reg) _mm256_add_%\alert<2>{\texttt{pd}}%((__mm256d) a, (__mm256d) b);
}
          \end{lstlisting}
        \end{column}
      \end{columns}
      \item \textbf{C++ template specialization technique}
    \end{itemize}
    \item \textbf{Instruction set selection} based on preprocessor definitions
  \end{itemize}
\end{frame}

\begin{frame}[fragile]
  \frametitle{\MIPP: Medium Level Interface (med.)}
  Typed registers, polymorphic operations
  \vspace{0.3cm}
  \begin{itemize}
    \item \textcolor{red}{Typed}, portable SIMD \textbf{data register} (\texttt{mipp::Reg<\textcolor{blue}{T}>})
    \begin{itemize}
      \item Contains a \MIPP low data register (\verb|mipp::reg|)
    \end{itemize}
    \item \textcolor{red}{Typed}, portable SIMD \textbf{mask register} (\texttt{mipp::Msk<\textcolor{blue}{N}>})
    \begin{itemize}
      \item Contains a \MIPP low mask register (\verb|mipp::msk|)
    \end{itemize}
    \item Supports \textcolor{red}{\textbf{operator overloading}}
    \begin{itemize}
      \item \texttt{mipp::Reg<\textcolor{blue}{float}> a = 1.f, b = 2.f; \textcolor{blue}{auto} c = a + b;}
    \end{itemize}
    \item Eases the \textcolor{red}{\textbf{register initializations}} (broadcasts, sets and loads)
    \begin{itemize}
      \item \texttt{mipp::Reg<\textcolor{blue}{int}> a = 1, b = \{1, 2, 3, 4\}, c = ptr;}
    \end{itemize}
    \item Defines an \textbf{aligned memory allocator} for the \texttt{std::vector<\textcolor{blue}{T},\textcolor{blue}{A}>} class (\texttt{mipp::vector<\textcolor{blue}{T}>})
  \end{itemize}
\end{frame}

\subsection{Simple Code Example}

\begin{frame}[containsverbatim,fragile]
  \frametitle{\MIPP: Hello World!}
  \begin{columns}[t]
    \begin{column}[T]{7.0cm}
      \begin{lstlisting}[style = mycpp, label={lst:add}, morekeywords = {T}]
template <typename T>
void vecAdd(const std::vector<T> &A,
            const std::vector<T> &B,
                  std::vector<T> &C)
{
	// N elements per SIMD register
	constexpr int N = mipp::N<T>();

	// sizes verifications
	assert(A.size() == B.size());
	assert(A.size() == C.size());
	assert((A.size() % N) == 0);

	for(auto i = 0; i < A.size(); i += N)
	{
		mipp::Reg<T> rA = &A[i]; // SIMD load
		mipp::Reg<T> rB = &B[i]; // SIMD load

		mipp::Reg<T> rC = rA + rB; // SIMD addition

		rC.store(&C[i]); // SIMD store
	}
}
      \end{lstlisting}
    \end{column}
  \end{columns}
  \pause
  \begin{itemize}
    \item \MIPP operates at \textbf{register level}
    \item Same code can \textbf{work on various data types} and instruction sets
  \end{itemize}
\end{frame}

\subsection{Masking Support}

\begin{frame}[fragile]
  \frametitle{\MIPP: Masking Support}
  \begin{itemize}
    \item In the \verb|AVX-512| instruction set:
    \begin{itemize}
      \item Height \textbf{dedicated hardware mask registers} (\verb|k0, k1, ..., k7|)
      \item Some \textbf{operations can be masked}
    \end{itemize}
  \end{itemize}
  \begin{figure}[htp]
    \centering
    \includegraphics[width=1.0\textwidth]{pics/mask_avx-512.png}
    \caption{Picture from \textcolor{blue}{\url{colfaxresearch.com}}}
    \label{pic:avx-512}
  \end{figure}
  \vspace{-0.6cm}
  \pause
  \begin{itemize}
    \item \MIPP takes advantage of the masked operations with a dedicated function:
          \textbf{\texttt{mipp::mask<T,mipp::op>(m, src, r1, r2)}} %ajouter une slide exemple pour montrer une application
  \end{itemize}
\end{frame}

\begin{frame}[containsverbatim,fragile]
  \frametitle{\MIPP: Masking Support (example)}
  \begin{figure}[htp]
    \centering
    \includegraphics[width=1.0\textwidth]{pics/mask_avx-512.png}
    % \caption{Picture from \textcolor{blue}{\url{colfaxresearch.com}}}
    \label{pic:avx-512}
  \end{figure}
  \begin{columns}[t]
    \begin{column}[T]{9.0cm}
      \begin{lstlisting}[style = mycpp, label={lst:msk}, escapechar=\%]
mipp::Reg<        float   > ZMM1 = {   40,  %\alert<2>{\texttt{-30}}%,    60,    80};
mipp::Reg<        float   > ZMM2 = 0.1; // broadcast
mipp::Msk<mipp::N<float>()> k1   = {false, %\alert<2>{\texttt{\textcolor<1>{keyblue}{true}}}%, false, false};

// ZMM3 = k1 ? ZMM1 * ZMM2 : ZMM1;
auto ZMM3 = mipp::mask<float, mipp::mul>(k1, ZMM1, ZMM1, ZMM2);

std::cout << ZMM3 << std::endl; // [   40,   %\alert<2>{\texttt{\textcolor<1>{commentgreen}{-3}}}%,    60,    80]
      \end{lstlisting}
    \end{column}
  \end{columns}
\end{frame}

\section{Experimentation Protocol}

\subsection{Experimentation Protocol}

\begin{frame}[fragile]
  \frametitle{Experimentation Protocol}
  \begin{itemize}
    \item Experiments
    \begin{itemize}
    \item \textbf{5G standard} related case studies
    \item Comparison to \textbf{related works} on Mandelbrot set
    \end{itemize}
    \item Tests are \textbf{mono-threaded}
    \item GNU \Cxx compiler version 5
  \end{itemize}
  \vspace{-0.3cm}
  \begin{table}[htp]
    \tabcolsep=6pt
    \centering
    % \caption{Specifications of the target processors}
    \label{tab:targets}
    {\small\resizebox{\linewidth}{!}{
    \begin{tabular}{c|c|c|c}
    \alert<2>{\textbf{Instr. set}}  & \alert<2>{\textbf{\texttt{NEON}}} & \alert<2>{\textbf{\texttt{SSE / AVX}}} & \alert<2>{\textbf{\texttt{AVX-512}}} \\ \hline
    \textbf{Name}                   & \textbf{Exynos5422}               & \textbf{Core i5-5300U}                 & \textbf{Xeon Phi 7230}               \\ \hline
    \textbf{Year}                   & 2014                              & 2015                                   & 2016                                 \\ \hline
    \textbf{Vendor}                 & Samsung                           & Intel                                  & Intel                                \\ \hline
    \multirow{2}{*}{\textbf{Arch.}} & ARMv7                             & x86-64                                 & Knights                              \\
                                    & Cortex A15                        & Broadwell                              & Landing                              \\ \hline
    \textbf{Cores/Freq.}            & 4/2.0 GHz                         & 2/2.3 GHz                              & 64/1.3 GHz                           \\ \hline
    \textbf{LLC}                    & 2 MB L2                           & 3 MB L3                                & 32 MB L2                             \\ \hline
    \textbf{TDP}                    & $\sim$4 W                         & 15 W                                   & 215 W                                \\
    \end{tabular}
    }}
  \end{table}
\end{frame}

\section{5G Standard: Case Studies}

\subsection{Box-Muller Transform}

\begin{frame}[containsverbatim,fragile]
  \frametitle{5G Case Studies: Box-Muller Transform}
  \scriptsize

  % The Box-Muller transform converts \textbf{uniformly-distributed random variables} ($U_1$ and $U_2$) into \textbf{Gaussian random variables} ($Z_1$ and $Z_2$):
  % \begin{equation*}
  %   Z_1 = \sqrt{-2 \log{U_1}}.\cos(2\pi.U_2)),~Z_2 = \sqrt{-2 \log{U_1}}.\sin(2\pi.U_2)).
  % \end{equation*}

  \begin{figure}[htp]
    \centering
    \includegraphics[width=0.6\textwidth]{figs/communication_chain_chn}
  \end{figure}

  \begin{columns}[t]
    \begin{column}[T]{6.0cm}
      \begin{lstlisting}[style = mycpp, basicstyle=\tiny, label={lst:boxmuller}]
void BoxMuller(const std::vector<float> &U
                     std::vector<float> &Z)
{
	constexpr auto N = mipp::N<float>();
	const auto nElmts = U.size();
	const auto twoPi = 2.f * 3.141592f;
	for (auto i = 0; i < nElmts; i += N * 2)
	{
		auto u1 = mipp::Reg<float>(&U[   i]);
		auto u2 = mipp::Reg<float>(&U[N +i]);
		auto r = mipp::sqrt(mipp::log(u1)*-2.f);
		auto theta  = u2 * twoPi;
		mipp::Reg<float> sinTheta, cosTheta;
		mipp::sincos(theta, sinTheta, cosTheta);
		auto z1 = r * cosTheta;
		auto z2 = r * sinTheta;
		z1.store(&Z[   i]);
		z2.store(&Z[N +i]);
	}
}
      \end{lstlisting}
    \end{column}
    \begin{column}[T]{5.5cm}
      \vspace{1cm}
      \begin{itemize}
        \item \textbf{20\%\,--\,50\% of simulation time}% tilde
        \item \MIPP includes \verb|sqrt|, \verb|log|, \verb|exp|,\\
              \verb|sin|, \verb|cos| and \verb|sincos| math functions
      \end{itemize}
      \pause
      \begin{table}[htp]
        \tabcolsep=6pt
        \centering
        % \caption{Measured speedups compared to the sequential versions of the code:}
        \label{tab:sp_awgn}
        {\small\resizebox{1\linewidth}{!}{
        \begin{tabular}{r|r|r|r|r}
                                  & \textbf{\texttt{NEON}} & \textbf{\texttt{SSE}} & \textbf{\texttt{AVX}} & \textbf{\texttt{AVX-512}} \\ \hline
        \textbf{SIMD size}        & 4                      & 4                     & 8                     & 16                        \\ \hline
        \textbf{Seq. T/P} (Mb/s)  & 13.2                   & 46.7                  & 42.5                  & 6.6                       \\ \hline
        \textbf{\MIPP T/P} (Mb/s) & 40.9                   & 107.4                 & 178.3                 & 95.1                      \\ \hline
        \textbf{Speedup}          & $\times 3.1$           & $\times 2.3$          & $\times 4.2$          & $\times 14.4$             \\
        \end{tabular}
        }}
      \end{table}
    \end{column}
  \end{columns}
\end{frame}

\subsection{Quantizer}

\begin{frame}[containsverbatim,fragile]
  \frametitle{5G Case Studies: Quantizer}
  \scriptsize

  % The quantizer converts the \textbf{floating-point representation} ($y$) after the channel into the \textbf{fixed-point representation} ($y_{s,v}$) just before the decoding process:
  % \begin{equation*}
  %   % y_{s,v} = \min(\max(2^v . y \pm 0.5, -2^{s-1} +1), 2^{s-1} -1),
  %   y_{s,v} = \Psi(2^v . y \pm 0.5),~\Psi(x) = min(max(x, -2^{s-1} +1), 2^{s-1} -1).
  % \end{equation*}

  \begin{figure}[htp]
    \centering
    \includegraphics[width=0.6\textwidth]{figs/communication_chain_chn}
  \end{figure}

  \begin{columns}[t]
    \begin{column}[T]{6.0cm}
      \begin{lstlisting}[style = mycpp, basicstyle=\fontsize{4.5}{4}\selectfont, label={lst:qnt}]
void Quantizer(const std::vector<float > &Y,
                     std::vector<int8_t> &Ysv,
               const unsigned s, const unsigned v) {
	constexpr auto N = mipp::N<float>();
	const auto pow2 = mipp::Reg<float>(1 << v);
	const float qMax = (1 << (s-2)) + (1 << (s-2)) -1;
	const float qMin = -qMax;
	for (auto y = 0; y < Y.size(); y += 4 * N) {
		// implicit loads and q = 2^v * y +/- 0.5
		auto q32_0 = mipp::round(pow2 * &Y[y + 0*N]);
		auto q32_1 = mipp::round(pow2 * &Y[y + 1*N]);
		auto q32_2 = mipp::round(pow2 * &Y[y + 2*N]);
		auto q32_3 = mipp::round(pow2 * &Y[y + 3*N]);
		// convert float to int32_t
		auto q32i_0 = mipp::cvt<int32_t>(q32_0);
		auto q32i_1 = mipp::cvt<int32_t>(q32_1);
		auto q32i_2 = mipp::cvt<int32_t>(q32_2);
		auto q32i_3 = mipp::cvt<int32_t>(q32_3);
		// pack four int32_t in two int16_t
		auto q16i_0 = mipp::pack<int32_t,int16_t>(q32i_0,
		                                          q32i_1);
		auto q16i_1 = mipp::pack<int32_t,int16_t>(q32i_2,
		                                          q32i_3);
		// pack two int16_t in one int8_t
		auto q8i = mipp::pack<int16_t,int8_t>(q16i_0, q16i_1);
		// saturation (psi function)
		auto q8is = mipp::sat(q8i, qMin, qMax);
		q8is.store(&Ysv[y]);
	}
}
      \end{lstlisting}
    \end{column}
    \begin{column}[T]{5.5cm}
      \vspace{0.5cm}
      \begin{itemize}
        \item \textbf{Converts} 32-bit floating-point numbers into 8-bit integers
        \item \textbf{Auto-vectorization is very bad} when data conversions are involved
        \item \MIPP provides \verb|round|, \verb|cvt| and \verb|pack| functions
      \end{itemize}
      \vspace{-0.2cm}
      \pause
      \begin{table}[hbp]
        \tabcolsep=6pt
        \centering
        % \caption{Measured speedups compared to the sequential versions of the code:}
        \label{tab:sp_quantizer}
        {\small\resizebox{1\linewidth}{!}{
        \begin{tabular}{r|r|r|r}
                                  & \textbf{\texttt{NEON}} & \textbf{\texttt{SSE}} & \textbf{\texttt{AVX}} \\ \hline
        \textbf{SIMD size}        & 4-16                   & 4-16                  & 8-32                  \\ \hline
        \textbf{Seq. T/P} (Mb/s)  & 65.3                   & 227.0                 & 218.2                 \\ \hline
        \textbf{\MIPP T/P} (Mb/s) & 300.6                  & 3541.4                & 5628.3                \\ \hline
        \textbf{Speedup}          & $\times 4.6$           & $\times 15.6$         & $\times 25.8$         \\
        \end{tabular}
        }}
      \end{table}
    \end{column}
  \end{columns}
\end{frame}

\subsection{LDPC Codes Decoding}

\begin{frame}[containsverbatim,fragile]
  \frametitle{5G Case Studies: LDPC Codes Decoding (BP Min-Sum)}
  \scriptsize
  \begin{figure}[htp]
    \centering
    \includegraphics[width=0.6\textwidth]{figs/communication_chain}\\
  \end{figure}
  \vspace{-0.6cm}
  \begin{columns}[t]
    \begin{column}[T]{6.0cm}
      \begin{lstlisting}[style = mycpp, basicstyle=\fontsize{4.5}{4}\selectfont, label={lst:LDPC}, morekeywords = {T}]
template <typename T>
void DecBP(const std::vector<std::vector<unsigned>> &H
                 std::vector<mipp::Reg  <T       >> &VN
                 std::vector<mipp::Reg  <T       >> &M,
                 std::vector<mipp::Reg  <T       >> &C
           const unsigned                           nIte) {
	const auto max = std::numeric_limits<T>::max();
	const auto zero = mipp::Reg<T>(0);
	for (auto i = 0; i < nIte; i++) {
		auto mRead = 0, mWrite = 0;
		for (auto c = 0; c < H.size(); c++) {
			constexpr auto N = mipp::N<T>();
			auto sign = mipp::Msk<N>(false);
			auto min1 = mipp::Reg<T>(max);
			auto min2 = mipp::Reg<T>(max);
			for (auto v = 0; v < H[c].size(); v++) {
				C[v] = VN[H[c][v]] - M[mRead++];
				auto cabs = mipp::abs(C[v]);
				auto ctmp = min1;
				sign ^= mipp::sign(C[v]);
				min1  = mipp::min(min1,           cabs       );
				min2  = mipp::min(min2, mipp::max(cabs, ctmp));
			}
			auto cst1 = mipp::blend(zero, min2, zero > min2);
			auto cst2 = mipp::blend(zero, min1, zero > min1);
			for (auto v = 0; v < H[c].size(); v++) {
				auto cval = C[v];
				auto cabs = mipp::abs(cval);
				auto cres = mipp::blend(cst1, cst2, cabs == min1);
				auto csig = sign ^ mipp::sign(cval);
				     cres = mipp::copysign(cres, csig);
				M[mWrite++] = cres;
				VN[H[c][v]] = C[v] + cres;
} } } }
      \end{lstlisting}
    \end{column}
    \begin{column}[T]{5.5cm}
      \vspace{+1.0cm}
      \begin{itemize}
        \item \textbf{Same code for various data types} (\verb|double|, \verb|float|, \verb|int32_t|, \verb|int16_t|)
        \item Decodes multiple frames (\verb|N|) in parallel (SIMD \textbf{inter-frame strategy})
      \end{itemize}
      \pause
      \begin{table}[htp]
        \tabcolsep=6pt
        \centering
        % \caption{Measured speedups compared to the sequential versions of the code (\texttt{int16\_t}, 10 iterations):}
        \label{tab:sp_ldpc}
        {\small\resizebox{1\linewidth}{!}{
        \begin{tabular}{r|r|r|r}
                                  & \textbf{\texttt{NEON}} & \textbf{\texttt{SSE}} & \textbf{\texttt{AVX}} \\ \hline
        \textbf{SIMD size}        & 8                      & 8                     & 16                    \\ \hline
        \textbf{Seq. T/P} (Mb/s)  & 0.9                    & 3.4                   & 3.5                   \\ \hline
        \textbf{\MIPP T/P} (Mb/s) & 8.3                    & 30.3                  & 53.2                  \\ \hline
        \textbf{Speedup}          & $\times 9.7$           & $\times 8.8$          & $\times 15.2$         \\
        \end{tabular}
        }}
      \end{table}
    \end{column}
  \end{columns}
\end{frame}

\subsection{Polar Codes Decoding}

\begin{frame}[containsverbatim,fragile]
  \frametitle{5G Case Studies: Polar Codes Decoding (SC)}
  \scriptsize

  \begin{figure}[htp]
    \centering
    \includegraphics[width=0.6\textwidth]{figs/communication_chain}\\
  \end{figure}

  \begin{columns}[t]
    \begin{column}[T]{6.0cm}
      % Polar code decoders elementary functions:
      % \vspace{-0.3cm}
      % {\tiny
      %   \begin{eqnarray*}
      %     \left\{\begin{array}{l c l}
      %       f(\lambda_a,\lambda_b) &=& sign(\lambda_a.\lambda_b).\min(|\lambda_a|,|\lambda_b|)\\
      %       g(\lambda_a,\lambda_b,\hat{s}_a)&=&(1-2\hat{s}_a)\lambda_a+\lambda_b\\
      %       h(\hat{s}_a,\hat{s}_b)&=& (\hat{s}_{a} \oplus \hat{s}_{b}, \hat{s}_{b})
      %     \end{array}\right.
      %     \label{eq:f_g}
      %   \end{eqnarray*}
      % }
      %\vspace{-0.3cm}
      \begin{lstlisting}[style = mycpp, basicstyle=\fontsize{5}{5}\selectfont, label={lst:Polar}, morekeywords = {T, N}]
template <typename T>
mipp::Reg<T> f_SIMD(const mipp::Reg<T> &la,
                    const mipp::Reg<T> &lb)
{
	auto abs_la  = mipp::abs(la);
	auto abs_lb  = mipp::abs(lb);
	auto min_abs = mipp::min(abs_la, abs_lb);
	auto sign    = mipp::sign(la ^ lb);
	// neg(Reg, Msk) = Msk ? -Reg : Reg;
	return mipp::neg(min_abs, sign);
}

template <typename T, int N = mipp::N<T>()>
mipp::Reg<T> g_SIMD(const mipp::Reg<T> &la,
                    const mipp::Reg<T> &lb,
                    const mipp::Msk<N> &sa)
{
	return mipp::neg(la, sa) + lb;
}

template <int N>
mipp::Msk<N> h_SIMD(const mipp::Msk<N>& sa,
                    const mipp::Msk<N>& sb)
{
	return sa ^ sb;
}
      \end{lstlisting}
    \end{column}
    \begin{column}[T]{5.5cm}
      \vspace{+0.5cm}
      \begin{itemize}
        \item \textbf{Same code for various data types} (\verb|double|, \verb|float|, \verb|int16_t|, \verb|int8_t|)
        \item Decodes frame per frame (SIMD \textbf{intra-frame strategy})
      \end{itemize}
      % \vspace{-0.3cm}
      \pause
      \begin{table}[hbp]
        \tabcolsep=6pt
        \centering
        % \caption{Measured speedups compared to the sequential versions of the code (\texttt{int8\_t}):}
        \label{tab:sp_polar}
        {\small\resizebox{1\linewidth}{!}{
        \begin{tabular}{r|r|r|r}
                                  & \textbf{\texttt{NEON}} & \textbf{\texttt{SSE}} & \textbf{\texttt{AVX}} \\ \hline
        \textbf{SIMD size}        & 16                     & 16                    & 32                    \\ \hline
        \textbf{Seq. T/P} (Mb/s)  & 48.0                   & 120.1                 & 127.1                 \\ \hline
        \textbf{\MIPP T/P} (Mb/s) & 148.7                  & 528.3                 & 483.0                 \\ \hline
        \textbf{Speedup}          & $\times 3.1$           & $\times 4.4$          & $\times 3.8$          \\
        \end{tabular}
        }}
      \end{table}
    \end{column}
  \end{columns}
\end{frame}

\section{Related works}

\subsection{Other Wrappers}

\begin{frame}[fragile]
  \frametitle{Related works: SIMD Wrappers}
    Two main strategies:
    \begin{enumerate}
      \item \textbf{operator overloading} (used in \MIPP)
      \item \textbf{expression templates}, can automatically match instructions like Fused Multiply–Add (FMA, $d = a \times b + c$)
    \end{enumerate}
  % prendre la marge à gauche
  \begin{table}[htp]
  % \renewcommand{\arraystretch}{0.95}
  \tabcolsep=6pt
  \centering
  % \caption{Comparison of various SIMD wrappers.}
  \label{tab:comp}
  {\small\resizebox{1.0\linewidth}{!}{
  \begin{tabular}{|r|r||c|c|c|c||c|c|c|c|c|c||c|c|}
  \hline
  \multicolumn{2}{|c||}{\multirow{2}{*}{\textbf{General Information}}}              & \multicolumn{4}{c||}{\multirow{2}{*}{\textbf{Instruction Set}}}                                    & \multicolumn{6}{c||}{\multirow{2}{*}{\textbf{Data Type}}}                    & \multicolumn{2}{c|}{\multirow{2}{*}{\textbf{Features}}} \\
  \multicolumn{2}{|c||}{}                                                           & \multicolumn{4}{c||}{}                                                                             & \multicolumn{6}{c||}{}                                                       & \multicolumn{2}{c|}{}                                   \\ \hline
  \multicolumn{2}{|r||}{\textbf{Name}}                                              & \textbf{\texttt{SSE}} & \textbf{\texttt{AVX}} & \textbf{\texttt{AVX-512}} & \textbf{\texttt{NEON}} & \multicolumn{2}{c|}{\textbf{Float}} & \multicolumn{4}{c||}{\textbf{Integer}} & \textbf{Math}  & \textbf{\Cxx}                          \\ \cline{7-12}
  \multicolumn{2}{|r||}{}                                                           & 128-bit               & 256-bit               & 512-bit                   & 128-bit                & 64      & 32                        & 64     & 32     & 16     & 8           & \textbf{Func.} & \textbf{Technique}                     \\ \hline \hline
  \multirow{8}{*}{\rotatebox[origin=c]{90}{\textbf{Library}}} & \textbf{\MIPP}      & \cmark                & \cmark                & \cmark                    & \cmark                 & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \cmark      & \cmark         & Op. overload.                          \\ %\cline{2-19}
                                                              & \textbf{\VCL}       & \cmark                & \cmark                & \cmark                    & \xmark                 & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \cmark      & \cmark         & Op. overload.                          \\ %\cline{2-19}
                                                              & \textbf{\simdpp}    & \cmark                & \cmark                & \cmark                    & \cmark                 & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \cmark      & \xmark         & Expr. templ.                           \\ %\cline{2-19}
                                                              & \textbf{\TSIMD}     & \cmark                & \cmark                & \xmark                    & \cmark                 & \xmark  & \cmark                    & \xmark & \cmark & \cmark & \cmark      & \xmark         & Op. overload.                          \\ %\cline{2-19}
                                                              & \textbf{\Vc}        & \cmark                & \cmark                & \xmark                    & \xmark                 & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \xmark      & \cmark         & Op. overload.                          \\ %\cline{2-19}
                                                              & \textbf{\xsimd}     & \cmark                & \cmark                & \xmark                    & \xmark                 & \cmark  & \cmark                    & \cmark & \cmark & \xmark & \xmark      & \cmark         & Op. overload.                          \\ %\cline{2-19}
                                                              & \textbf{\BoostSIMD} & \cmark                & \xmark                & \xmark                    & \xmark                 & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \cmark      & \cmark         & Expr. templ.                           \\ %\cline{2-19}
                                                              & \textbf{\bSIMD}     & \cmark                & \cmark                & \cmark                    & \cmark                 & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \cmark      & \cmark         & Expr. templ.                           \\ \hline
  \end{tabular}
  }}
  \end{table}

\end{frame}

\subsection{Mandelbrot Set}

\begin{frame}[containsverbatim,fragile]{movie}
  \frametitle{Related works: Comparison on the Mandelbrot Set}
  \small

  \vspace{-0.3cm}
  % \begin{columns}[t]
  %   \begin{column}[T]{7.5cm}
%       \begin{lstlisting}[style = mycpp, caption={Sequential kernel}, basicstyle=\fontsize{4.5}{4}\selectfont, label={lst:Polar}, morekeywords = {T, N}]
% void mandelbrot(const int maxite, unsigned *pixels) {
% 	for (auto y = 0; y < HEIGHT; y++) {
% 		for (auto x = 0; x < WIDTH; x++) {
% 			float zr, zi, cr, ci, m = 0.;
% 			// get the complex point to be calculated
% 			zr = cr = CENTERR + (x - (WIDTH /2)) / ZOOM;
% 			zi = ci = CENTERI + (y - (HEIGHT/2)) / ZOOM;
% 			// applies the actual Mandelbrot formula
% 			for (auto n = 0; n <= maxite && m < STOP; n++) {
% 				float a = zr * zr - zi * zi + cr;
% 				float b = zr * (zi + zi) + ci;
% 				zr = a;
% 				zi = b;
% 				m = a * a + b * b;
% 			}
% 			pixels[y*WIDTH +x] = n;
% }	}	}
%       \end{lstlisting}
      \begin{itemize}
        \item \textbf{Computational intensive} kernel
        \item Need to manage an \textbf{early termination}
        \item \Cxx code is freely available\footnote{Full code is available online: \textcolor{blue}{\url{https://gitlab.inria.fr/acassagn/mandelbrot}}}
      \end{itemize}
  %   \end{column}
  %   \begin{column}[T]{5.0cm}
  %     \vspace{-0.3cm}
  %     \begin{figure}[htp]
  %       \centering
  %       % \includegraphics[width=0.8\textwidth]{pics/mandelbrot}
  %         \movie[label=mandelbrot,width=0.8\textwidth,poster,start=0s,autostart]
  %         {\includegraphics[width=.8\textwidth]{pics/mandelbrot}}{movs/mandelbrot.mov}
  %     \end{figure}
  %   \end{column}
  % \end{columns}
  \pause
  \vspace{-0.4cm}
  \begin{figure}[htp]
    \centering
    \includegraphics[width=0.8\textwidth]{graphs/mandelbrot_speedup}
  \end{figure}
\end{frame}

\section{Conclusion}

\subsection{Conclusion and Future Works}

\begin{frame}[fragile]
  \frametitle{Conclusion and Future Works}
  \textbf{Conclusion:}
  \begin{enumerate}
    \item<1-> \textbf{SIMD wrapper} dedicated to digital communication algorithms
    \item<2-> Matches both \textbf{simulation} and \textbf{embedded software} constraints
    \item<3-> \textbf{Outperforms} most ECC software solutions on CPUs
    \item<4-> \textbf{Used by hardware designers} in academic and industrial research\footnote<4->{\texttt{AFF3CT} Open-source toolbox: \textcolor{blue}{\url{http://aff3ct.github.io}}}
  \end{enumerate}
  \vspace{+1.0cm}
  \pause[5]
  \textbf{Future works:}
  \begin{itemize}
    \item Wraps the new \textbf{ARM Scalable Vector Extension} (SVE)
    \begin{itemize}
      \item Predicate registers would likely map on \MIPP masks
      \item Main challenge will be to deal with \textbf{agnostic vector sizes}
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]
  \center
  {\huge Thank you!}
  \vspace{0.9cm}
  \begin{itemize}
    \item \MIPP code: \textcolor{blue}{\url{https://github.com/aff3ct/MIPP}}
    \item \texttt{AFF3CT} toolbox: \textcolor{blue}{\url{https://github.com/aff3ct/aff3ct}}
  \end{itemize}
\end{frame}

% \begin{frame}[allowframebreaks]
%   \frametitle{References}
%   \bibliographystyle{plain}
%   \bibliography{article.bib}
% \end{frame}

\end{document}
